#pragma once

class CSettingItem
{
public:
	CSettingItem() : m_Use_TsSplitter(TRUE), m_Use_make_gl(TRUE), m_Use_ts2aac(TRUE),
			m_Use_aactool(FALSE), m_Use_FAW(TRUE), m_Use_CAP2ASS(TRUE)
	{
	}
	~CSettingItem() {}

	CString m_SettingName;
	CString m_BatchFile;

	BOOL m_Use_TsSplitter;
	BOOL m_Use_make_gl;
	BOOL m_Use_ts2aac;
	BOOL m_Use_aactool;
	BOOL m_Use_FAW;
	BOOL m_Use_CAP2ASS;

	CString m_TsSplitter_opt;
	CString m_ts2aac_opt;
	CString m_aactool_opt;
	CString m_CAP2ASS_opt;

	CString m_options;
};

class CSettings
{
public:
	CSettings(void);
	~CSettings(void);
	int Load(void);
	int Save(void);

	CString m_IniFileName;
	CString m_ExeFileName;
	CString m_ExeDirectory;

	CString m_LastInputPath;
	CString m_DefaultOutputPath;
	CString m_TsSplitter;
	CString m_make_gl;
	CString m_ts2aac;
	CString m_aactool;
	CString m_FAW;
	CString m_CAP2ASS;

	CSimpleArray<CSettingItem> m_SettingList;
	int m_SelectNum;

	BOOL WritePrivateProfileString(LPCTSTR lpSecName, LPCTSTR lpKeyName, LPCTSTR lpString)
	{
		return ::WritePrivateProfileString(lpSecName, lpKeyName, lpString, m_IniFileName);
	}
	BOOL WritePrivateProfileInt(LPCTSTR lpSecName, LPCTSTR lpKeyName, INT nVal)
	{
		CString str;
		str.Format(_T("%d"), nVal);
		return WritePrivateProfileString(lpSecName, lpKeyName, str);
	}
	DWORD GetPrivateProfileString(LPCTSTR lpSecName, LPCTSTR lpKeyName, LPCTSTR lpDefault,
			CString& strReturnedString)
	{
		TCHAR buf[MAX_PATH];
		DWORD ret = ::GetPrivateProfileString(lpSecName, lpKeyName, lpDefault,
				buf, _countof(buf), m_IniFileName);
		if (ret) {
			strReturnedString = buf;
		}
		return ret;
	}
	UINT GetPrivateProfileInt(LPCTSTR lpSecName, LPCTSTR lpKeyName, INT nDefault)
	{
		return ::GetPrivateProfileInt(lpSecName, lpKeyName, nDefault, m_IniFileName);
	}
};
